/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.tool;

import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.OperationApplicationException;
import android.database.Cursor;
import android.os.RemoteException;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.ui.NotesListAdapter.AppWidgetAttribute;

import java.util.ArrayList;
import java.util.HashSet;


/**
 * 数据工具类，提供对数据进行操作的静态方法。
 */
public class DataUtils {
    /**
     * 日志标签，用于日志输出时标识来源。
     */
    public static final String TAG = "DataUtils";

    /**
     * 批量删除笔记。
     * 此方法接受一组笔记ID，并执行批量删除操作。
     * 
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param ids 待删除笔记的ID集合。
     * @return 如果删除操作成功，返回true；如果失败或ID集合为空/为null，返回false。
     */
    public static boolean batchDeleteNotes(ContentResolver resolver, HashSet<Long> ids) {
        // 如果传入的ID集合为null，记录日志并返回true（视为无操作）
        if (ids == null) {
            Log.d(TAG, "the ids is null");
            return true;
        }
        // 如果ID集合大小为0，即没有ID需要删除，记录日志并返回true
        if (ids.size() == 0) {
            Log.d(TAG, "no id is in the hashset");
            return true;
        }

        // 创建操作列表，用于批量操作
        ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
        // 遍历ID集合，为每个ID创建一个删除操作
        for (long id : ids) {
            // 检查是否为根文件夹ID，如果是则跳过删除
            if(id == Notes.ID_ROOT_FOLDER) {
                Log.e(TAG, "Don't delete system folder root");
                continue;
            }
            // 创建删除操作的构建器，并添加到操作列表
            ContentProviderOperation.Builder builder = ContentProviderOperation
                    .newDelete(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
            operationList.add(builder.build());
        }
        try {
            // 执行批量操作
            ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
            // 如果结果为空或结果数组长度为0或结果数组第一个元素为null，记录日志并返回false
            if (results == null || results.length == 0 || results[0] == null) {
                Log.d(TAG, "delete notes failed, ids:" + ids.toString());
                return false;
            }
            // 如果批量操作成功，返回true
            return true;
        } catch (RemoteException e) {
            // 捕获并记录远程异常
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        } catch (OperationApplicationException e) {
            // 捕获并记录操作应用异常
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        }
        // 如果发生异常，返回false
        return false;
    }

    /**
     * 将单个笔记移动到指定文件夹。
     * 
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param id 待移动笔记的ID。
     * @param srcFolderId 笔记当前所在的文件夹ID。
     * @param desFolderId 目标文件夹ID。
     */
    public static void moveNoteToFoler(ContentResolver resolver, long id, long srcFolderId, long desFolderId) {
        // 创建一个ContentValues对象，用于存储需要更新的值
        ContentValues values = new ContentValues();
        // 更新笔记的父文件夹ID为新的目标文件夹ID
        values.put(NoteColumns.PARENT_ID, desFolderId);
        // 记录笔记原始的父文件夹ID
        values.put(NoteColumns.ORIGIN_PARENT_ID, srcFolderId);
        // 标记笔记为本地修改，值为1
        values.put(NoteColumns.LOCAL_MODIFIED, 1);
        // 更新指定笔记的记录
        resolver.update(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id), values, null, null);
    }

    /**
     * 批量将笔记移动到指定文件夹。
     * 此方法接受一组笔记ID，并执行批量移动操作。
     * 
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param ids 待移动笔记的ID集合。
     * @param folderId 目标文件夹ID。
     * @return 如果移动操作成功，返回true；如果失败或ID集合为空/为null，返回false。
     */
    public static boolean batchMoveToFolder(ContentResolver resolver, HashSet<Long> ids,
            long folderId) {
        // 如果传入的ID集合为null，记录日志并返回true（视为无操作）
        if (ids == null) {
            Log.d(TAG, "the ids is null");
            return true;
        }

        // 创建操作列表，用于批量操作
        ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
        // 遍历ID集合，为每个ID创建一个更新操作
        for (long id : ids) {
            // 创建更新操作的构建器，并设置新的父文件夹ID和本地修改标记
            ContentProviderOperation.Builder builder = ContentProviderOperation
                    .newUpdate(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
            builder.withValue(NoteColumns.PARENT_ID, folderId);
            builder.withValue(NoteColumns.LOCAL_MODIFIED, 1);
            // 将构建好的操作添加到操作列表
            operationList.add(builder.build());
        }

        try {
            // 执行批量操作
            ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
            // 如果结果为空或结果数组长度为0或结果数组第一个元素为null，记录日志并返回false
            if (results == null || results.length == 0 || results[0] == null) {
                Log.d(TAG, "delete notes failed, ids:" + ids.toString());
                return false;
            }
            // 如果批量操作成功，返回true
            return true;
        } catch (RemoteException e) {
            // 捕获并记录远程异常
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        } catch (OperationApplicationException e) {
            // 捕获并记录操作应用异常
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        }
        // 如果发生异常，返回false
        return false;
    }
}

    /**
     * Get the all folder count except system folders {@link Notes#TYPE_SYSTEM}}
     */
    public static int getUserFolderCount(ContentResolver resolver) {
        // 查询数据库，获取非回收站文件夹的总数
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { "COUNT(*)" },
                NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>?",
                new String[] { String.valueOf(Notes.TYPE_FOLDER), String.valueOf(Notes.ID_TRASH_FOLER)},
                null);

        int count = 0;
        // 如果游标不为空，移动到第一行并获取计数
        if (cursor != null) {
            if (cursor.moveToFirst()) {
                try {
                    count = cursor.getInt(0);
                } catch (IndexOutOfBoundsException e) {
                    Log.e(TAG, "get folder count failed:" + e.toString());
                } finally {
                    cursor.close();
                }
            }
        }
        return count;
    }

    /**
     * 检查笔记在数据库中是否可见。
     * 根据笔记类型和笔记ID查询数据库，判断笔记是否存在。
     * 
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param noteId 笔记ID。
     * @param type 笔记类型。
     * @return 如果笔记存在且可见，返回true；否则返回false。
     */
    public static boolean visibleInNoteDatabase(ContentResolver resolver, long noteId, int type) {
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
                null,
                NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER,
                new String[] {String.valueOf(type)},
                null);

        boolean exist = false;
        if (cursor != null) {
            if (cursor.getCount() > 0) {
                exist = true;
            }
            cursor.close();
        }
        return exist;
    }

    /**
     * 检查笔记ID在数据库中是否存在。
     * 
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param noteId 笔记ID。
     * @return 如果笔记ID存在，返回true；否则返回false。
     */
    public static boolean existInNoteDatabase(ContentResolver resolver, long noteId) {
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
                null, null, null, null);

        boolean exist = false;
        if (cursor != null) {
            if (cursor.getCount() > 0) {
                exist = true;
            }
            cursor.close();
        }
        return exist;
    }

    /**
     * 检查数据ID在数据库中是否存在。
     * 此方法通过查询数据库来确定特定数据ID是否存在。
     *
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param dataId 要检查的数据ID。
     * @return 如果数据ID存在，返回true；否则返回false。
     */
    public static boolean existInDataDatabase(ContentResolver resolver, long dataId) {
        // 构建查询，获取特定数据ID的记录
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId),
                null, null, null, null);

        boolean exist = false;
        // 如果查询结果的游标不为空，处理查询结果
        if (cursor != null) {
            // 如果游标计数大于0，表示记录存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭游标，释放资源
            cursor.close();
        }
        // 返回是否存在的结果
        return exist;
    }

    /**
     * 检查给定名称的文件夹是否在数据库中已存在。
     * 此方法查询数据库中非回收站类型的文件夹，检查是否有重名。
     *
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param name 要检查的文件夹名称。
     * @return 如果文件夹已存在，返回true；否则返回false。
     */
    public static boolean checkVisibleFolderName(ContentResolver resolver, String name) {
        // 构建查询，获取特定名称的文件夹记录
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI, null,
                NoteColumns.TYPE + "=" + Notes.TYPE_FOLDER +
                " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER +
                " AND " + NoteColumns.SNIPPET + "=?",
                new String[] { name }, null);
        boolean exist = false;
        // 如果查询结果的游标不为空，处理查询结果
        if (cursor != null) {
            // 如果游标计数大于0，表示文件夹已存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭游标，释放资源
            cursor.close();
        }
        // 返回文件夹是否存在的结果
        return exist;
    }

    /**
     * 获取文件夹中笔记的小部件属性集合。
     * 此方法查询数据库中属于特定文件夹的所有笔记的小部件属性。
     *
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param folderId 要查询的文件夹ID。
     * @return 包含小部件属性的HashSet集合，如果文件夹ID不存在则返回null。
     */
    public static HashSet<AppWidgetAttribute> getFolderNoteWidget(ContentResolver resolver, long folderId) {
        // 构建查询，获取特定文件夹ID下所有笔记的小部件属性
        Cursor c = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { NoteColumns.WIDGET_ID, NoteColumns.WIDGET_TYPE },
                NoteColumns.PARENT_ID + "=?",
                new String[] { String.valueOf(folderId) },
                null);

        HashSet<AppWidgetAttribute> set = null;
        // 如果查询结果的游标不为空，处理查询结果
        if (c != null) {
            // 如果游标有数据，创建HashSet集合并填充数据
            if (c.moveToFirst()) {
                set = new HashSet<AppWidgetAttribute>();
                do {
                    try {
                        AppWidgetAttribute widget = new AppWidgetAttribute();
                        widget.widgetId = c.getInt(0);
                        widget.widgetType = c.getInt(1);
                        set.add(widget);
                    } catch (IndexOutOfBoundsException e) {
                        Log.e(TAG, e.toString());
                    }
                } while (c.moveToNext());
            }
            // 关闭游标，释放资源
            c.close();
        }
        // 返回小部件属性集合
        return set;
    }

    /**
     * 根据笔记ID获取对应的通话记录号码。
     * 此方法查询数据库中对应笔记ID的通话记录号码。
     * 如果未找到对应ID的通话记录或者查询过程中出现错误，则返回空字符串。
     *
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param noteId 要查询的笔记ID。
     * @return 对应笔记ID的通话记录号码，如果未找到或查询出错则返回空字符串。
     */
    public static String getCallNumberByNoteId(ContentResolver resolver, long noteId) {
        // 构建查询，获取特定笔记ID的通话记录号码
        Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
                new String[] { CallNote.PHONE_NUMBER },
                CallNote.NOTE_ID + "=? AND " + CallNote.MIME_TYPE + "=?",
                new String[] { String.valueOf(noteId), CallNote.CONTENT_ITEM_TYPE },
                null);

        // 如果查询结果的游标不为空且有数据，处理查询结果
        if (cursor != null && cursor.moveToFirst()) {
            try {
                // 返回获取到的通话记录号码
                return cursor.getString(0);
            } catch (IndexOutOfBoundsException e) {
                // 如果发生索引越界异常，记录错误日志
                Log.e(TAG, "Get call number fails " + e.toString());
            } finally {
                // 无论是否成功获取数据，都关闭游标释放资源
                cursor.close();
            }
        }
        // 如果查询结果为空、查询失败或发生异常，返回空字符串
        return "";
    }


    /**
     * 根据电话号码和通话日期获取对应的笔记ID。
     * 此方法查询数据库中符合特定电话号码和通话日期的笔记，并返回其ID。
     * 如果未找到符合条件的笔记，则返回0。
     *
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param phoneNumber 要查询的电话号码。
     * @param callDate 要查询的通话日期。
     * @return 对应电话号码和通话日期的笔记ID，如果未找到则返回0。
     */
    public static long getNoteIdByPhoneNumberAndCallDate(ContentResolver resolver, String phoneNumber, long callDate) {
        // 构建查询，获取特定电话号码和通话日期的笔记ID
        Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
                new String[] { CallNote.NOTE_ID },
                CallNote.CALL_DATE + "=? AND " + CallNote.MIME_TYPE + "=? AND PHONE_NUMBERS_EQUAL("
                + CallNote.PHONE_NUMBER + ",?)",
                new String[] { String.valueOf(callDate), CallNote.CONTENT_ITEM_TYPE, phoneNumber },
                null);

        // 如果查询结果的游标不为空，处理查询结果
        if (cursor != null) {
            // 如果游标有数据，移动到第一行并获取笔记ID
            if (cursor.moveToFirst()) {
                try {
                    // 返回获取到的笔记ID
                    return cursor.getLong(0);
                } catch (IndexOutOfBoundsException e) {
                    // 如果发生索引越界异常，记录错误日志
                    Log.e(TAG, "Get call note id fails " + e.toString());
                }
            }
            // 关闭游标，释放资源
            cursor.close();
        }
        // 如果未找到符合条件的笔记或查询过程中发生错误，返回0
        return 0;
    }
    /**
     * 根据笔记ID获取笔记的摘要。
     * 此方法查询数据库中对应ID的笔记，并获取其摘要字段。
     * 如果未找到对应ID的笔记，则抛出IllegalArgumentException异常。
     *
     * @param resolver ContentResolver实例，用于访问数据库。
     * @param noteId 要查询的笔记ID。
     * @return 对应笔记ID的摘要字符串，如果找到了笔记。
     * @throws IllegalArgumentException 如果未找到对应ID的笔记。
     */
    public static String getSnippetById(ContentResolver resolver, long noteId) {
        // 构建查询，获取特定笔记ID的摘要字段
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { NoteColumns.SNIPPET },
                NoteColumns.ID + "=?",
                new String[] { String.valueOf(noteId) },
                null);

        // 初始化摘要字符串
        String snippet = "";
        // 如果查询结果的游标不为空，处理查询结果
        if (cursor != null) {
            // 如果游标有数据，移动到第一行并获取摘要
            if (cursor.moveToFirst()) {
                snippet = cursor.getString(0);
            }
            // 关闭游标，释放资源
            cursor.close();
            // 返回获取到的摘要
            return snippet;
        }
        // 如果游标为null，表示查询失败或未找到对应的笔记，抛出异常
        throw new IllegalArgumentException("Note is not found with id: " + noteId);
    }

    /**
     * 获取格式化的笔记摘要。
     * 移除摘要中的换行符，并截取到第一个换行符之前的内容。
     * 
     * @param snippet 原始笔记摘要。
     * @return 格式化后的笔记摘要。
     */
    public static String getFormattedSnippet(String snippet) {
        // 如果传入的摘要不为null，则进行处理
        if (snippet != null) {
            // 去除摘要字符串前后的空白字符
            snippet = snippet.trim();
            // 寻找摘要中第一个换行符的位置
            int index = snippet.indexOf('\n');
            // 如果存在换行符，则截取换行符之前的内容
            if (index != -1) {
                snippet = snippet.substring(0, index);
            }
        }
        // 返回处理后的摘要字符串，如果原始摘要为null，则返回null
        return snippet;
    }
}